
/* Chrysalide - Outil d'analyse de fichiers binaires
 * instruction.h - prototypes pour la gestion des instructions de la VM Dalvik
 *
 * Copyright (C) 2010-2017 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _ARCH_DALVIK_INSTRUCTION_H
#define _ARCH_DALVIK_INSTRUCTION_H


#include "instruction-def.h"
#include "../instruction.h"



#define G_TYPE_DALVIK_INSTRUCTION                 g_dalvik_instruction_get_type()
#define G_DALVIK_INSTRUCTION(obj)                 (G_TYPE_CHECK_INSTANCE_CAST((obj), g_dalvik_instruction_get_type(), GDalvikInstruction))
#define G_IS_DALVIK_INSTRUCTION(obj)              (G_TYPE_CHECK_INSTANCE_TYPE((obj), g_dalvik_instruction_get_type()))
#define G_DALVIK_INSTRUCTION_GET_IFACE(inst)      (G_TYPE_INSTANCE_GET_INTERFACE((inst), g_dalvik_instruction_get_type(), GDalvikInstructionIface))


/* Définition générique d'une instruction d'architecture Dalvik (instance) */
typedef struct _GDalvikInstruction GDalvikInstruction;

/* Définition générique d'une instruction d'architecture Dalvik (classe) */
typedef struct _GDalvikInstructionClass GDalvikInstructionClass;


/* Indique le type défini pour une instruction d'architecture Dalvik. */
GType g_dalvik_instruction_get_type(void);

/* Crée une instruction pour l'architecture Dalvik. */
GArchInstruction *g_dalvik_instruction_new(const char *);

/* Indique l'opcode associé à une instruction Dalvik. */
DalvikOpcodes g_dalvik_instruction_get_opcode(const struct _GDalvikInstruction *);



/* --------------------- AIDE A LA MISE EN PLACE D'INSTRUCTIONS --------------------- */




/* ------------------------ AIDE A LA PHASE DE DECOMPILATION ------------------------ */



#endif  /* _ARCH_DALVIK_INSTRUCTION_H */
